part of leadlinkopenapi;


class APIFeedback {

  // 获取反馈问题列表(APP端)
  static void getProblemTypeList({Function(List<ProblemType> problemTypeList) onSucc, Function(String) onFail}) async {

    try {

      var queryBuider = QueryBuilder<ProblemType>(ProblemType())
      ..whereNotEqualTo('isActive', false);
      
      var resp = await queryBuider.query();

      if(resp.success == false) {
        if(onFail != null) onFail(APITip.apiFail);
        return;
      }
      if(onSucc != null) onSucc(resp.results.cast<ProblemType>());
    } catch (e) {
      if(onFail != null) onFail(APITip.apiFail);
      return;
    }

  }

  // 提交反馈问题（APP端）
  static void commitProblemFeedBack(int productId,String message,String contactWay,{Function() onSucc, Function(String) onFail}) async {

    try {

      // 获取用户
      APIUser.currentUserInfo(onFail: onFail,onSucc: (user) async {

          final userResp = await ParseObject('Users').getObject(user['objectId']);
          ParseObject userObject = userResp.results.first;
          
          // 获取产品
          APIProduct.getProductDetailByProductId(productId,onFail: onFail,onSucc: (product) async {

              final productResp = await ParseObject('Product').getObject(product['objectId']);
              ParseObject prodcutObject = productResp.results.first;

              var cntQuery = QueryBuilder<ParseObject>(ParseObject("Counters"))
              ..whereEqualTo('name', 'ProblemFeedback');
              var cntResp = await cntQuery.query();
              ParseObject counter = cntResp.results.first;

              ParseObject item      = ParseObject('ProblemFeedback');
              item['message']       = message ?? '';
              item['contactWay']    = contactWay ?? '';
              item['isActive']      = true;

              item['fromUser']      = userObject;
              item['product']       = prodcutObject;
              item['feedBackId']    = counter['next'];

              await item.save();

              counter.setIncrement('next', 1);
              await counter.save();

              if(onSucc !=null) onSucc();              

            }
          );
        }
      );

    } catch (e) {
      if(onFail != null) onFail(APITip.apiFail);
      return;
    }

  }
}



