part of leadlinkopenapi;


//版本更新
class APIPackageUpdate {

  // 获取iOS版本信息
  static getRemotePackageUpdateForIOS({Function(PackageUpdate pkg) onSucc,Function(String) onFail}) async {

    try {

        var queryBuider = QueryBuilder<PackageUpdate>(PackageUpdate())
        ..whereEqualTo('platform', 'ios');
        var resp = await queryBuider.query();

      if(resp.success == false) {
        if(onFail != null) onFail(APITip.apiFail);
        return;
      }
      if(resp.results.length == 0) {
        if(onFail != null) onFail(APITip.apiFail);
        return;
      }
      PackageUpdate pkg = resp.results.first;
      if(onSucc != null) onSucc(pkg);

    } catch (e) {
      if(onFail != null) onFail(APITip.apiFail);
      return;
    }

  }

  // 获取Android版本信息
  static getRemotePackageUpdateForAndroid({Function(PackageUpdate pkg) onSucc,Function(String) onFail}) async {
    try {

        var queryBuider = QueryBuilder<PackageUpdate>(PackageUpdate())
        ..whereEqualTo('platform', 'android');
        var resp = await queryBuider.query();

      if(resp.success == false) {
        if(onFail != null) onFail(APITip.apiFail);
        return;
      }
      if(resp.results.length == 0) {
        if(onFail != null) onFail(APITip.apiFail);
        return;
      }
      PackageUpdate pkg = resp.results.first;
      if(onSucc != null) onSucc(pkg);

    } catch (e) {
      if(onFail != null) onFail(APITip.apiFail);
      return;
    }
  }

}