part of leadlinkopenapi;


class APIScheme {

  // 提交方案-仅名字
  static void commitScheme(String schemeName,int skuId,bool isForever,String deadline,{Function() onSucc, Function(String) onFail}) {

    try {
      
      // 获取用户
      APIUser.currentUserInfo(onFail: onFail,onSucc: (user) async {

          final userResp = await ParseObject('Users').getObject(user['objectId']);
          ParseObject userObject = userResp.results.first;

          // 获取sku
           APIProductSKU.getProductSKUById(skuId,onFail: onFail,onSucc: (product) async {

              final productResp = await ParseObject('ProductSKU').getObject(product['objectId']);
              ParseObject skuObject = productResp.results.first;

              var cntQuery = QueryBuilder<ParseObject>(ParseObject("Counters"))
              ..whereEqualTo('name', 'UserScheme');
              var cntResp = await cntQuery.query();
              ParseObject counter = cntResp.results.first;

              ParseObject item    = ParseObject('UserScheme');
              item['sku']         = skuObject;
              item['user']        = userObject;
              item['name']        = schemeName ?? '';
              item['isActive']    = true;

              item['isForever']   = isForever ?? true;
              item['deadline']    = deadline ??'';

              item['schemeId']    = counter['next'];
              await item.save();

              counter.setIncrement('next', 1);
              await counter.save();

              if(onSucc !=null) onSucc();              

            });
      });

    } catch (e) {
      if(onFail !=null) onFail(APITip.apiFail);     
    }

  }

    // 提交方案-名字+用户名+登录密码+操作密码
  static void commitSchemeWithAccountNameAndPswd(String schemeName,int skuId,bool isForever,String deadline,
  String accountName,String loginPassword,String handlePassword,
  {Function() onSucc, Function(String) onFail}) {

    try {
      
      // 获取用户
      APIUser.currentUserInfo(onFail: onFail,onSucc: (user) async {

          final userResp = await ParseObject('Users').getObject(user['objectId']);
          ParseObject userObject = userResp.results.first;

          // 获取sku
           APIProductSKU.getProductSKUById(skuId,onFail: onFail,onSucc: (product) async {

              final productResp = await ParseObject('ProductSKU').getObject(product['objectId']);
              ParseObject skuObject = productResp.results.first;

              var cntQuery = QueryBuilder<ParseObject>(ParseObject("Counters"))
              ..whereEqualTo('name', 'UserScheme');
              var cntResp = await cntQuery.query();
              ParseObject counter = cntResp.results.first;

              ParseObject item    = ParseObject('UserScheme');
              item['sku']         = skuObject;
              item['user']        = userObject;
              item['name']        = schemeName ?? '';
              item['isActive']    = true;

              item['isForever']   = isForever ?? true;
              item['deadline']    = deadline ??'';

              item['accountName']    = accountName ?? '';
              item['loginPassword']  = loginPassword ?? '';
              item['handlePassword'] = handlePassword ?? '';

              item['schemeId']    = counter['next'];
              await item.save();

              counter.setIncrement('next', 1);
              await counter.save();

              if(onSucc !=null) onSucc();              

            });
      });

    } catch (e) {
      if(onFail !=null) onFail(APITip.apiFail);     
    }

  }


  // 获取当前用户下所有方案
  static getAllSchemeListByCurrentUser({Function(List<UserScheme>) onSucc, Function(String) onFail}) async {

    try {

         SharedPreferences prefs = await SharedPreferences.getInstance();
         int userId = prefs.getInt(APITip.spKeyUserId) ?? 0 ;
         if(userId == 0){
           if(onFail != null) onFail(APITip.apiNoLogin);
           return;
         }

        var queryUser = QueryBuilder<Users>(Users())
        ..whereNotEqualTo('isActive', false)
        ..whereEqualTo('userId', userId);

        var queryBuider = QueryBuilder<UserScheme>(UserScheme())
        ..whereNotEqualTo('isActive', false)
        ..whereMatchesQuery('user',queryUser)
        ..includeObject(['user','user.userType','sku','sku.product','sku.product.accessType','sku.product.productCategory']);

        var resp = await queryBuider.query();

        if(resp.success == false) {
          if(onFail != null) onFail(APITip.apiFail);
          return;
        }

      if(onSucc != null) onSucc(resp.results.cast<UserScheme>());         

    } catch (e) {
      if(onFail != null) onFail(APITip.apiFail);
      return;
    }
    
  }

  // 获取当前用户下,根据品类Id获取方案列表
  static getSchemeListByCategoryId(int categoryId,{Function(List<UserScheme>) onSucc, Function(String) onFail}) async {
    
    try {

         SharedPreferences prefs = await SharedPreferences.getInstance();
         int userId = prefs.getInt(APITip.spKeyUserId) ?? 0 ;
         if(userId == 0){
           if(onFail != null) onFail(APITip.apiNoLogin);
           return;
         }

        var queryCat = QueryBuilder<ProductCategory>(ProductCategory())
        ..whereEqualTo('productCategoryId', categoryId);

        var queryProduct = QueryBuilder<Product>(Product())
        ..whereMatchesQuery('productCategory',queryCat);

        var querySku = QueryBuilder<ProductSKU>(ProductSKU())
        ..whereMatchesQuery('product',queryProduct);
        

        var queryUser = QueryBuilder<Users>(Users())
        ..whereEqualTo('userId', userId);

  
        var queryBuider = QueryBuilder<UserScheme>(UserScheme())
        ..whereNotEqualTo('isActive', false)
        ..whereMatchesQuery('user',queryUser)
        ..whereMatchesQuery('sku',querySku)
        ..includeObject(['user','user.userType','sku','sku.product','sku.product.accessType','sku.product.productCategory']);

         var resp = await queryBuider.query();

        if(resp.success == false) {
          if(onFail != null) onFail(APITip.apiFail);
          return;
        }

      if(onSucc != null) onSucc(resp.results.cast<UserScheme>());         

    } catch (e) {
      if(onFail != null) onFail(APITip.apiFail);
      return;
    }
  }
}